#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct jelka {
	char boja[20];
	char oblik[20];
	int bal;
	struct jelka *levi,*desni;
} JELKA ;

int Dubina(JELKA *p)
{
	int dd=0;
	int dl=0;
		if(p)
		{
			if(p->levi) dl=Dubina(p->levi);
			if (p->desni) dd=Dubina(p->desni);
			if(dl>dd) return ++dl;
				else return ++dd;
		}
	else return 0;
} 

JELKA *lrotacija(JELKA *p)
{
	JELKA *pom;
	pom=p->desni->levi;
	p->desni->levi=p;
	p=p->desni;
	p->levi->desni=pom;
	
	p->levi->bal=Dubina(p->levi->desni)-Dubina(p->levi->levi);
    p->bal=Dubina(p->desni)-Dubina(p->levi);
	return p;
}

JELKA *drotacija(JELKA *p)
{
	JELKA *pom;
	pom=p->levi->desni;
	p->levi->desni=p;
	p=p->levi;
	p->desni->levi=pom;
	
	p->desni->bal=Dubina(p->desni->desni)-Dubina(p->desni->levi);
	p->bal=Dubina(p->desni)-Dubina(p->levi);
	return p;
}


int Dodaj(JELKA **p2,JELKA *temp)
{
	int ink,rezultat;
	JELKA *p;
	
	p=(*p2);
	rezultat=0;
	
	if(p==NULL)
	{
		p=temp;
		p->desni=NULL;
		p->levi=NULL;
		p->bal=0;
		rezultat=1;
	}
	else 
	{
		if ((strcmp(temp->boja,p->boja)==0) && (strcmp(temp->oblik,p->oblik)==0))
			ink=Dodaj(&(p->desni),temp);
			else
			ink=-Dodaj(&(p->levi),temp);
			p->bal+=ink;
		
		if(ink != 0 && p->bal != 0)
		{ 
			if(p->bal<-1)
			{
				if(p->levi->bal<0)
				{
					p=drotacija(p);
				}
				else
				{
					
					p->levi=lrotacija(p->levi);
					p=drotacija(p);
				}
				}
			if(p->bal>1)
			{
				if(p->levi->bal>0)
				{
					p=lrotacija(p);
				}
				else
				{
					
					p->desni=drotacija(p->desni);
					p=lrotacija(p);
				}
				}
		
		else rezultat=1;

	}
	}
			
		(*p2)=p;
		return rezultat;
}

void Kreiraj(JELKA **p2)
{
	char boja[20];
	char oblik[20];
	int n,i;
	JELKA *p;
	JELKA *temp;
	
	p=(*p2);
	
	scanf("%d",&n);
	getchar();
	for(i=0;i<n;i++)
	{
		
		temp=malloc(sizeof(JELKA));
		
		gets(boja);
		strcpy(temp->boja,boja);
		gets(oblik);
		strcpy(temp->oblik,oblik);
		Dodaj(&p,temp);
		
	}
	(*p2)=p;
}

void Ispis(JELKA *p)
{
	if(p!=NULL)
	{
		Ispis(p->levi);
		printf("%s %s\n",p->boja,p->oblik);
		Ispis(p->desni);
	}
	
}

JELKA *Brisanje(JELKA *p,JELKA *NOVO,char provera[])
{
	if (p!=NULL) {
	NOVO=Brisanje(p->levi,NOVO,provera);
	NOVO=Brisanje(p->desni,NOVO,provera);
	p->levi=NULL;
	p->desni=NULL;
	if (strcmp(p->oblik,provera)!=0)
	Dodaj(&NOVO,p);
 }
 return NOVO;
}

void Stampa(JELKA *p)
{
	
	if (p!=NULL)
	printf("Oblik ukrasa na vrhu jelke je:\n");
	printf("%s\n",p->oblik);
	
}

void Stampaa(JELKA *p)
{
	if (p!=NULL)
	printf("Boja ukrasa na vrhu jelke je: \n");
	printf("%s\n",p->boja);
}


main()
{
	JELKA *p=NULL;
	Kreiraj(&p);
	Ispis(p);
	Stampa(p);
	char provera[20];
	strcpy(provera,p->oblik);
	p=Brisanje(p,NULL,provera);
	Ispis(p);
	Stampaa(p);
}
