#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

enum{Crven, Crn};

struct drvo{
	char *bojau, *oblik;
	int boja;
	struct drvo *roditelj, *levi, *desni;
};

#define novi(x) x = (struct drvo *)malloc(sizeof(struct drvo))
#define novichar(x,y) x = (char*)malloc(strlen(y)*sizeof(char))
int br1;
void nadji(struct drvo *p, char *boja){
	nadji(p->levi, boja);
	nadji(p->desni, boja);
	if(strcmp(p->bojau, boja)==0)
		br1++;
}
int poredjenje(struct drvo *a, struct drvo *b){
	if(strcmp(a->bojau,"zlatna")==0){
//		printf("poredjenje1\n");
		if(strcmp(b->bojau,"zlatna")==0)
			return 2;
		else if(strcmp(b->bojau,"crvena")==0)
			return 0;
		else
			return 0;
	}
	else if(strcmp(a->bojau,"crvena")==0){
//		printf("poredjenje2\n");
		if(strcmp(b->bojau,"crvena")==0)
			return 2;
		else if(strcmp(b->bojau,"zlatna")==0)
			return 1;
		else
			return 0;
	}
	else if(strcmp(a->bojau,"srebrna")==0){
//		printf("poredjenje3\n");
		if(strcmp(b->bojau,"srebrna")==0)
			return 2;
		else if(strcmp(b->bojau,"zlatna")==0)
			return 1;
		else
			return 1;
	}
//	printf("poredjenje4\n");
}

void lrotacija(struct drvo **t){
	struct drvo *x, *y;
	x = *t;
	y = x->desni;
	x->desni = y->levi;
	if(y->levi)
		y->levi->roditelj = x;
	y->roditelj = x->roditelj;
	if(x->roditelj)
		if(x->roditelj->levi)
			x->roditelj->levi = y;
		else
			x->roditelj->desni = y;
	y->levi = x;
	x->roditelj = y;
	*t = y;
}
void drotacija(struct drvo **t){
	struct drvo *x, *y;
	x = *t;
	y = x->levi;
	x->levi = y->desni;
	if(y->desni)
		y->desni->roditelj = x;
	y->roditelj = x->roditelj;
	if(x->roditelj)
		if(x->roditelj->levi)
			x->roditelj->levi = y;
		else
			x->roditelj->desni = y;
	y->desni = x;
	x->roditelj = y;
	*t = y;
}
void bojefix(struct drvo **p, struct drvo *z){
	struct drvo *y, *t;
//	printf("bojefix1\n");
	while((z->roditelj)&&(z->roditelj->boja == Crven)){
		if(z->roditelj->roditelj->levi){
//			printf("bojefix11\n");
			y = z->roditelj->roditelj->desni;
			if((y)&&(y->boja == Crven)){
//				printf("bojefix12\n");
				z->roditelj->boja = Crn;
				y->boja = Crn;
				y->roditelj->boja = Crven;
				z = z->roditelj->roditelj;
			}
			else{
//				printf("bojefix13\n");
				if((z == z->roditelj->desni)){
					z = z->roditelj;
					lrotacija(&z);
					if(!z->roditelj)
						*p = z;
					z = z->levi;
				}
//				printf("bojefix14\n");
				z->roditelj->boja = Crn;
				t = z->roditelj->roditelj;
				t->boja = Crven;
//				printf("bojefix15\n");
				drotacija(&t);
//				printf("bojefix16\n");
				if(!t->roditelj)
					*p = t;
			}
		}
		else{
			y = z->roditelj->roditelj->levi;
			if((y)&&(y->boja == Crven)){
//				printf("bojefix22\n");
				z->roditelj->boja = Crn;
				y->boja = Crn;
				y->roditelj->boja = Crven;
				z = z->roditelj->roditelj;
			}
			else{
//				printf("bojefix23\n");
				if((z == z->roditelj->levi)){
//					printf("bojefix24\n");
					z = z->roditelj;
					drotacija(&z);
					if(!z->roditelj)
						*p = z;
					z = z->desni;
				}
				z->roditelj->boja = Crn;
//				printf("bojefix26\n");
				t = z->roditelj->roditelj;
//				printf("bojefix27\n");
				t->boja = Crven;
//				printf("bojefix28\n");
				lrotacija(&t);
//				printf("bojefix29\n");
				if(!t->roditelj)
					*p = t;
			}
		}
	}
//	printf("poredjenje3\n");
	(*p)->boja = Crn;
}

void dodaj(struct drvo **koren, struct drvo *cvor){
	struct drvo *x, *y;
	int b=0;
	x = *koren;
	y = NULL;
	while(x){
		y = x;
		b = poredjenje(x,cvor);
		if(b==0)
			x = x->levi;
		else if(b==1)
			x = x->desni;
		else if ((strcmp(x->oblik,cvor->oblik))==0)
			x = x->desni;
		else
			x = x->levi;
	}
	cvor->roditelj = y;
	
//		printf("dodaj1\n");
	if(!y){
		*koren = cvor;
	}
	else{
		b = poredjenje(y,cvor);
//		printf("dodaj2\n");
		if(b==0)
			y->levi = cvor;
		else if(b==1)
			y->desni = cvor;
		else if ((strcmp(y->oblik,cvor->oblik))==0)
			y->desni = cvor;
		else
			y->levi = cvor;
	}
//		printf("dodaj3\n");
	bojefix(koren, cvor);
}

struct drvo *form(){
	struct drvo *koren = NULL, *cvor = NULL;
	int n, i;
	char ukras[50];
	printf("Unesite broj ukrasa: \t");
	scanf("%d", &n);
	for(i=0;i<n;i++)
	{
		novi(cvor);
		printf("Unesite boju ukrasa:\t");
		scanf("%s", ukras);
		novichar(cvor->bojau,ukras);
		strcpy(cvor->bojau, ukras);
		printf("Unesite oblik ukrasa:\t");
		scanf("%s", ukras);
		novichar(cvor->oblik,ukras);
		strcpy(cvor->oblik, ukras);
		cvor->levi = cvor->desni = NULL;
		cvor->boja = Crven;
		dodaj(&koren, cvor);
	}
	return koren;
}

void ispis(struct drvo *p){
	if(p){
		ispis(p->levi);
		if(p->boja == Crven)
			printf("Ukras: \t%s, %s, crven\n",p->bojau, p->oblik);
		else
			printf("Ukras: \t%s, %s, crn\n", p->bojau, p->oblik);
		ispis(p->desni);
	}
}

void brisi(struct drvo *p, struct drvo **q, char *oblik){
	struct drvo *cvor = NULL;
	if(p){
		if(!(strcmp(p->oblik,oblik)==0)){
			novi(cvor);
			novichar(cvor->oblik,p->oblik);
			strcpy(cvor->oblik, p->oblik);
			novichar(cvor->bojau,p->bojau);
			strcpy(cvor->bojau, p->bojau);
			cvor->levi = cvor->desni = NULL;
			cvor->boja = Crven;
			dodaj(q,cvor);
		}
		brisi(p->levi, q, oblik);
		brisi(p->desni, q,oblik);
	}
}
main(){
	struct drvo *p=NULL, *q=NULL;
	p = form();
	ispis(p);
	printf("Zvezda na vrhu jelke je: %s\n",p->oblik);
	brisi(p,&q,p->oblik);
	if(q)
	ispis(q);
	else
	printf("Skinuli ste sve ukrase!\n");
	printf("Zvezda na vrhu jelke je: %s\n",q->bojau);
	br1 = 0;
	int n1, n2;
	printf("dalje\n");
	nadji(q->levi,q->bojau);
	n1 = br1;
	br1 = 0;
	
	printf("dalje2\n");
	nadji(q->desni, q->bojau);
	n2 = br1;
	printf("dalje3\n");
	if(n1<n2)
		printf("vise ih ima desno\n");
	else if(n2<n1)
		printf("vise ih ima levo\n");
	else
		printf("Ima ih isto\n");
}
