#include<stdio.h>
#include<stdlib.h>
#include<string.h>
struct jelka {
	char boja[20];
	char oblik[20];
	int balans;
	struct jelka *levi,*desni;
};

int dubina(struct jelka*p){
	int dl=0,dd=0;
	if (p){
		if (p->levi) dl=dubina(p->levi);
		if (p->desni) dd=dubina(p->desni);
		if (dd>dl) return ++dd;
		else return ++dl;
	}
	return 0;
}

void lrotacija(struct jelka**p){
	struct jelka *poml,*pomd;
	poml=*p;
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*p=pomd;
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void drotacija(struct jelka**p){
	struct jelka *poml,*pomd;
	pomd=*p;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*p=poml;
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

int uredjenje(struct jelka*p,char boja[20],char oblik[20]){
	int l1,l2,d1,d2;
	if (!strcmp(p->boja,"crvena")) l1=0;
	else if (!strcmp(p->boja,"srebrna")) l1=1;
	else if (!strcmp(p->boja,"zlatna")) l1=2;
	
	if (!strcmp(p->oblik,"sfera")) l2=0;
	else if (!strcmp(p->oblik,"kocka")) l2=1;
	
	if (!strcmp(boja,"crvena")) d1=0;
	else if (!strcmp(boja,"srebrna")) d1=1;
	else if (!strcmp(boja,"zlatna")) d1=2;

	if (!strcmp(oblik,"sfera")) d2=0;
	else if (!strcmp(oblik,"kocka")) d2=1;
	
	if (l1<d1||(l1==d1&&l2<=d2)) return 1;
	else return 0;
}

void prebrojavanje(int *br,struct jelka*p,char boja[20]){
	if (p){
		if (p->levi) prebrojavanje(br,p->levi,boja);
		if (!strcmp(boja,p->boja)) ++(*br);
		if (p->desni) prebrojavanje(br,p->desni,boja);
	}
}

int levoildesno(struct jelka*p,char boja[20]){
	int levo=0,desno=0;
	prebrojavanje(&levo,p->levi,boja);
	prebrojavanje(&desno,p->desni,boja);
	//printf("Levo je %d, a desno %d sa tom bojom\n",levo,desno);
	if (levo>desno) return -1;
	else if (levo==desno) return 0; 
	else if (levo<desno) return 1;
}


void brisanje(struct jelka*p,struct jelka **q,char oblik[20]){
	if (p){
		if (p->levi) brisanje(p->levi,q,oblik);
		if (strcmp(p->oblik,oblik)) dodaj(q,p->boja,p->oblik); 
		if (p->desni) brisanje(p->desni,q,oblik);
	}
}

int dodaj(struct jelka**q,char boja[20],char oblik[20]){
	int inkrement,rezultat=0;
	struct jelka *p=*q;
	if (p==NULL){
		p=(struct jelka*)malloc(sizeof(struct jelka));
		strcpy(p->boja,boja);
		strcpy(p->oblik,oblik);
		p->levi=p->desni=NULL;
		p->balans=0;
		rezultat=1;	
	}
	else {
		if (uredjenje(p,boja,oblik)) inkrement=dodaj(&(p->desni),boja,oblik);
		else inkrement=-dodaj(&(p->levi),boja,oblik);
		p->balans+=inkrement;
		if (p->balans!=0&&inkrement!=0){
			if (p->balans<-1){
				if (p->levi->balans<0) drotacija(&p);
				else { lrotacija(&(p->levi)); drotacija(&p); }
			}
			else if (p->balans>1){
				if (p->desni->balans>0) lrotacija(&p);
				else { drotacija(&(p->desni)); lrotacija(&p); }
			}
			else rezultat=1;
		}
	}
	*q=p;
	return rezultat;
}

void ispis(struct jelka*p){
	if (p){
		if (p->levi) ispis(p->levi);
		printf("%s   %s   %d\n",p->boja,p->oblik,p->balans);
		if (p->desni) ispis(p->desni);
	}
}


main(){
	int i,n,x;
	char boja[20],oblik[20];
	struct jelka*koren=NULL,*koren2=NULL;
	//printf("Unesi n\n");
	scanf("%d",&n);
	getchar();
	//printf("Unosi ukrase\n");
	for (i=0;i<n;i++){
		gets(boja);
		gets(oblik);
		dodaj(&koren,boja,oblik);
	}
	printf("Jelka je \n");
	ispis(koren);
	printf("Na vrhu jelke oblik je %s\n",koren->oblik);
	brisanje(koren,&koren2,koren->oblik);
	printf("Jelka nakon brisanja ukrasa je\n");
	ispis(koren2);
	printf("Na vrhu jelke boja je %s\n",koren2->boja);
	x=levoildesno(koren2,koren2->boja);
	if (x==-1) printf("Vise ukrasa te boje ima u levom podstablu.\n");
	else if (x==1) printf("Vise ukrasa te boje ima u desnom podstablu.\n");
	else printf("Ima jednako u oba stabla.\n");
}





































