#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct drvo
{
	char *boja;
	char *oblik;
	int balans;
	struct drvo *levi,*desni;
};

#define novi(x) x=(struct drvo *)malloc(sizeof(struct drvo))


struct drvo *ucitaj()
{
	struct drvo *t;
	char s[10];

	novi(t);
	if(!t)
	{
		printf("alokacija nije uspela\n");
		exit(0);
	}
	
	printf("unesite boju ukrasa: ");
	gets(s);
	t->boja=(char *)malloc(strlen(s)+1);
	strcpy(t->boja,s);
	printf("unesite oblik ukrasa: ");
	gets(s);
	t->oblik=(char *)malloc(sizeof(s)+1);
	strcpy(t->oblik,s);
	t->balans=0;
	t->levi=t->desni=0;
	
	
	return t;
}

int dubina(struct drvo *p)
{
	if(!p) return 0;
	else
	{
		int dd,dl;
		dd=dl=0;
		if(p->desni) dd=dubina(p->desni);
		if(p->levi) dl=dubina(p->levi);
		if(dl>dd) return ++dl;
		else return ++dd;
	}
}


void lrotacija(struct drvo **p)
{
	struct drvo *pom1,*pom2;
	
	pom1=*p;
	
	pom2=pom1->desni;
	pom1->desni=pom2->levi;
	pom2->levi=pom1;
	
	*p=pom2;
	pom1->balans=dubina(pom1->desni)-dubina(pom1->levi);
	pom2->balans=dubina(pom2->desni)-dubina(pom2->levi);
}

void drotacija(struct drvo **p)
{
	struct drvo *pom1,*pom2;
	
	pom1=*p;
	
	pom2=pom1->levi;
	pom1->levi=pom2->desni;
	pom2->desni=pom1;
	
	*p=pom2;
	pom1->balans=dubina(pom1->desni)-dubina(pom1->levi);
	pom2->balans=dubina(pom2->desni)-dubina(pom2->levi);
}

int bojaa(char *s)
{
	if(strcmp(s,"srebrna")==0) return 0;
	else if(strcmp(s,"crvena")==0) return 1;
	else return 2;
}

int oblikk(char *s)
{
	if(strcmp(s,"sfera")==0) return 0;
	else return 1;
}

int dodaj(struct drvo **p, struct drvo *t)
{
	struct drvo *tem;
	int ink,rez=0;
	
	tem=*p;
	if(!tem)
	{
		tem=t;
		*p=tem;
		rez=1;
	}
	else
	{
		if((bojaa(t->boja) > bojaa(tem->boja)) || ((bojaa(t->boja)==bojaa(tem->boja)) && (oblikk(t->oblik)>=oblikk(tem->oblik)))) ink=dodaj(&(tem->desni),t);
		else ink=-dodaj(&(tem->levi),t);
		
		tem->balans += ink;
		if((ink!=0) && (tem->balans!=0))
		{
			if(tem->balans >1)
			{
				if(tem->desni->balans > 0) lrotacija(&tem);
				else
				{
					drotacija(&(tem->desni));
					lrotacija(&tem);
				}
			}
			else if(tem->balans <-1)
			{
				if(tem->levi->balans < 0) drotacija(&tem);
				else
				{
					lrotacija(&(tem->levi));
					drotacija(&tem);
				}
			}
			else rez=1;
		}
		
	}
	
	*p=tem;
	return rez;
}



struct drvo *form()
{
	struct drvo *p,*t;
	int i,n;
	p=NULL;
	printf("Unesite broj n: ");
	scanf("%d",&n);
	getchar();
	
	
	for(i=0;i<n;i++)
	{
		t=ucitaj();
		dodaj(&p,t);
	
	}
	return p;
	
	
}

void brisi(struct drvo *p, struct drvo **q, char *obli)
{
	if(p)
	{
		if((strcmp(p->oblik,obli)!=0))
		{
			dodaj(q,p);
			
			if(p->levi) brisi(p->levi,q,obli);
			if(p->desni) brisi(p->desni,q,obli);
		}
		else
		{
			if(p->levi) brisi(p->levi,q,obli);
			if(p->desni) brisi(p->desni,q,obli);
		}
	}
	else return;
}


void ispis(struct drvo *p)
{
	if(p)
	{
		if(p->levi) ispis(p->levi);
		printf("BOJA: %s OBLIK: %s BALANS: %d\n",p->boja,p->oblik,p->balans);
		if(p->desni) ispis(p->desni);
	}
}

int bro(struct drvo *p,char *s)
{
	int br=0;
	if(!p) return 0;
	else
	{
		if(strcmp(p->boja,s)==0)br++;
		if(p->levi) br += bro(p->levi,s);
		if(p->desni) br+= bro(p->desni,s);
		return br;
	}
	
}

void vrh(struct drvo *p)
{
	int lu,du;
	lu=du=0;
	printf("\nboja ukrasa na vrhu jelke je %s \n",p->boja);
	
	lu=bro(p->levi,p->boja);
	du=bro(p->desni,p->boja);
	
	if(lu>du) printf("vise ima ukrasa u levom podstablu\n");
	else if(lu<du) printf("vise ima ukrasa u desnom podstablu\n");
	else printf("jednak broj ukrasa u oba podstabla\n");
}

int main()
{
	struct drvo *p,*q;
	q=NULL;
	
	p=form();
	
	ispis(p);
	
		
	
	
	if(p) 
	{
		printf("u vrhu je ukras oblika %s\n",p->oblik);
		brisi(p,&q,p->oblik);
		
	}
	else printf("nema stabla\n");
	
	printf("\nstablo posle brisanja\n");
	ispis(q);
	
	
	vrh(q);

	
	return 0;
}
