#include<stdio.h>
#include<stdlib.h>
#include<string.h>

typedef struct cvor cvor;
struct cvor
{
	char *boja;
	char *oblik;
	int balans;
	cvor *levo,*desno;
};

cvor *alociraj()
{
		cvor *temp=(cvor*)malloc(sizeof(cvor));
		return temp;
}

int dubina(cvor *p)
{
		int dd=0,dl=0;
		if(p)
		{
		if (p->levo) dl=dubina(p->levo);
		if (p->desno) dd=dubina(p->desno);
		if (dd>dl) return dd++;
		else return dl++;
		}
		else return 0;
}

void lrotacija(cvor **p)
{
		cvor *poml,*pomd;
		poml=(*p);
		pomd=poml->desno;
		poml->desno=pomd->levo;
		pomd->levo=poml;
		(*p)=pomd;
		
		poml->balans=dubina(poml->desno)-dubina(poml->levo);
		pomd->balans=dubina(pomd->desno)-dubina(pomd->levo);
		
}
void drotacija(cvor **p)
{
		cvor *poml,*pomd;
		pomd=(*p);
		poml=pomd->levo;
		pomd->levo=poml->desno;
		poml->desno=pomd;
		(*p)=poml;
		
		poml->balans=dubina(poml->desno)-dubina(poml->levo);
		pomd->balans=dubina(pomd->desno)-dubina(pomd->levo);
		
}

int dodaj(cvor **p,cvor *temp)
{
		int rez=0,inkrement,a=0,b=0;
		cvor *pom=(*p);
		if(pom==NULL)
		{
				pom=temp;
				pom->balans=0;
				rez=1;
		}
		else
		{
			a=uporedi(pom);
			b=uporedi(temp);
			if(a>b)
				 inkrement=-dodaj(&(pom->levo),temp);
			else inkrement=dodaj(&(pom->desno),temp);
		
			pom->balans=pom->balans+inkrement;
			
			if((pom->balans!=0)&&(inkrement!=0))
			{
					if(pom->balans<-1)
					{
							if(pom->levo->balans<0)	drotacija(&pom);
							else
							{
									lrotacija(&(pom->levo));
									drotacija(&pom);
							}
					}
					else if(pom->balans>1)
					{
							if(pom->desno->balans>0) lrotacija(&pom);
							else
							{
									drotacija(&(pom->desno));
									lrotacija(&pom);
							}
					}
					else rez=1;
			}
		}
		(*p)=pom;
		return rez;
}

void *unos(cvor **p)
{
		cvor *pom=NULL,*temp=NULL;
		char b[10],o[10];
		int i,n;
		pom=(*p);
		printf("uneti n:");
		scanf("%d",&n);
		getchar();
		if (n<1) { printf("uneto n mora biti veci od 0"); exit(1);}
		else
		{
				for (i=0;i<n;i++)
				{
						temp=alociraj();
						printf("uneti boju:");
						gets(b);
						printf("uneti oblik:");
						gets(o);
						temp->boja=(char *)malloc(strlen(b+1)*sizeof(char));
						temp->oblik=(char *)malloc(strlen(o+1)*sizeof(char));
						strcpy(temp->boja,b);
						strcpy(temp->oblik,o);
						
						dodaj(&pom,temp);
				}
		}
		(*p)=pom;
}

int uporedi(cvor *p)
{
		int suma=0;
		if(p->boja=="srebrna\n");
		suma=suma+3;
		if(p->boja=="crvena\n");
		suma=suma+6;
		if(p->boja=="zlatna\n");
		suma=suma+9;
		
		if(p->oblik=="sfera\n");
		suma=suma+1;
		if(p->oblik=="kocka\n");
		suma=suma+2;
		
		printf("%d\n",suma);
		return suma;
}
void ispis(cvor *p)
{
		if(p)
		{
				if(p->levo) ispis(p->levo);
				printf("boja:%s\toblik:%s\tbalans<%d>",p->boja,p->oblik,p->balans);
				printf("\n");
				if(p->desno) ispis(p->desno);
		}
}
void ukras(cvor *p,cvor *pl,cvor *pd)
{
		int l=0,d=0;
		printf("%s\n",p->boja);
		if(pl)
		{
				if(strcmp(p->boja,pl->boja)==0)
				{	l++;
					ukras(p,pl->levo,pd);
					ukras(p,pl->desno,pd);
					}
		}
		if(pd)
		{
				if(strcmp(p->boja,pd->boja)==0)
				{
						d++;
						ukras(p,pl,pd->levo);
						ukras(p,pl,pd->desno);
				}
		}
		if(l>d) printf("ima vise levo.\n");
		if(d>l) printf("ima vise desno.\n");
		if (d==l) printf("jednak broj na obe strane.\n");
}
main()
{
		cvor *radi=NULL;
		unos(&radi);
		ispis(radi);
		ukras(radi,radi->levo,radi->desno);
}
