#include<stdio.h>
#include<stdlib.h>
#include<string.h>

enum{crvena,crna};

typedef struct drvo{
	int boja;
	char bojaU[10],oblik[10];
	struct drvo *roditelj,*levi,*desni;
}drvo;

#define novi(x) x = (drvo*) malloc(sizeof(drvo))

int provera_boja(char s[]){
	if(!strcmp(s,"srebrna")) return -1;
	if(!strcmp(s,"crvena")) return 0;
	if(!strcmp(s,"zlatna")) return 1;
	printf("GRESKA U PROVERI BOJA\n");
	return -2;
}

int provera_oblika(char s[]){
	if(!strcmp(s,"sfera")) return -1;
	if(!strcmp(s,"kocka")) return 1;
	printf("GRESKA U PROVERI BOJA\n");
	return -2;
}

void drotacija(drvo **p){
	drvo *x,*y;
	y = *p;
	x = y->levi;
	y->levi = x->desni;
	if(x->desni) x->desni->roditelj = y;
	x->roditelj = y->roditelj;
	if(y->roditelj)
		if(y == y->roditelj->desni) y->roditelj->desni = x;
		else y->roditelj->levi = x;
	y->roditelj = x;
	x->desni = y;
	*p = x;
}

void lrotacija(drvo **p){
	drvo *x,*y;
	x = *p;
	y = x->desni;
	x->desni = y->levi;
	if(y->levi) y->levi->roditelj = x;
	y->roditelj = x->roditelj;
	if(x->roditelj)
		if(x == x->roditelj->desni) x->roditelj->desni = y;
		else x->roditelj->levi = y;
	x->roditelj = y;
	y->levi = x;
	*p = y;
}

void bojefix(drvo **p,drvo *z){
	drvo *y,*t;
	while((z->roditelj) && (z->roditelj->boja == crvena)){
		if(z->roditelj == z->roditelj->roditelj->levi){
			y = z->roditelj->roditelj->desni;
			if((y) && (y->boja == crvena)){
				z->roditelj->boja = crna;
				z->roditelj->roditelj->boja = crvena;
				y->boja = crna;
				z = z->roditelj->roditelj;
			}
			else {
				if(z == z->roditelj->desni){
					z = z->roditelj;
					lrotacija(&z);
					if(!z->roditelj) *p = z;
					z = z->levi;
				}
				z->roditelj->boja = crna;
				z->roditelj->roditelj->boja = crvena;
				t = z->roditelj->roditelj;
				drotacija(&t);
				if(!t->roditelj) *p = t;
			}
		}
		else {
			y = z->roditelj->roditelj->levi;
			if((y) && (y->boja == crvena)){
				z->roditelj->boja = crna;
				z->roditelj->roditelj->boja = crvena;
				y->boja = crna;
				z = z->roditelj->roditelj;
			}
			else {
				if(z == z->roditelj->levi){
					z = z->roditelj;
					drotacija(&z);
					if(!z->roditelj) *p = z;
					z = z->desni;
				}
				z->roditelj->boja = crna;
				z->roditelj->roditelj->boja = crvena;
				t = z->roditelj->roditelj;
				lrotacija(&t);
				if(!t->roditelj) *p = t;
			}
		}
	}
	(*p)->boja = crna;
}
			

void dodaj(drvo **p,drvo *z){
	drvo *x,*y;
	x = *p;
	y = NULL;
	while(x){
		y = x;
		if(provera_boja(x->bojaU) > provera_boja(z->bojaU)) x = x->levi;
		 else if(provera_boja(x->bojaU) < provera_boja(z->bojaU)) x = x->desni;
		 else if(provera_boja(x->bojaU) == provera_boja(z->bojaU)){
			if(provera_oblika(x->oblik) > provera_oblika(z->oblik)) x = x->levi;
			else if(provera_oblika(x->oblik) < provera_oblika(z->oblik)) x = x->desni;
			 else if(provera_oblika(x->oblik) == provera_oblika(z->oblik)) x = x->desni;
		}
	}
	if(!y) *p = z;
	else {
		if(provera_boja(y->bojaU) > provera_boja(z->bojaU)) y->levi = z;
		else if(provera_boja(y->bojaU) < provera_boja(z->bojaU)) y->desni = z;
		 else if(provera_boja(y->bojaU) == provera_boja(z->bojaU)){
			if(provera_oblika(y->oblik) > provera_oblika(z->oblik)) y->levi = z;
			else if(provera_oblika(y->oblik) < provera_oblika(z->oblik)) y->desni = z;
			 else if(provera_oblika(y->oblik) == provera_oblika(z->oblik)) y->desni = z;
		}
		z->roditelj = y;
	}
	bojefix(p,z);
}
			

drvo* form(){
	drvo  *koren,*temp;
	koren = NULL;
	char s[10];
	int n,i;
	printf("Unesite broj ukrasa: ");
	scanf("%d",&n);
	getchar();
	for(i=0;i<n;i++){
		novi(temp);
		temp->roditelj = temp->levi = temp->desni = NULL;
		temp->boja = crvena;
		printf("Unesite boju: ");
		gets(s);
		strcpy(temp->bojaU,s);
		printf("Unesite oblik: ");
		gets(s);
		strcpy(temp->oblik,s);
		dodaj(&koren,temp);
	}
	printf("\n");
	return koren;
}

void ispis(drvo *p){
	if(p){
		ispis(p->levi);
		printf("Boja ukrasa  %7s, Oblik ukrasa %5s,  ",p->bojaU,p->oblik);
		if(p->boja == crvena) printf("boja elementa: CRVENA\n");
		else printf("boja elementa: CRNA\n");
		ispis(p->desni);
	}
}	

void brisi(drvo **q,drvo *p,char s[]){
	drvo *temp;
	if(p){
	if(strcmp(p->oblik,s)){
		novi(temp);
		strcpy(temp->oblik,p->oblik);
		strcpy(temp->bojaU,p->bojaU);
		temp->boja = crvena;
		temp->roditelj = temp->levi = temp->desni = NULL;
		dodaj(q,temp);
		brisi(q,p->levi,s);
		brisi(q,p->desni,s);
	}
	else {
		brisi(q,p->levi,s);
		brisi(q,p->desni,s);
	}
	}
}
		
int broj_ukrasa(drvo *p,char s[]){
	int k = 0;
	if(p){
		if (p->levi) k += broj_ukrasa(p->levi,s);
		if (p->desni) k += broj_ukrasa(p->desni,s);
		if (!strcmp(s,p->bojaU)) k += 1;
	}
	return k;
}		

main(){
	drvo *p,*q;
	q = NULL;
	char s[10];
	p = form(p);
	ispis(p);
	strcpy(s,p->oblik);
	printf("Oblik na vrhu je: %s \n",s);
	brisi(&q,p,s);
	ispis(q);
	strcpy(s,q->bojaU);
	printf("Boja na vrhu je: %s \n",s);
	if(broj_ukrasa(q->levi,s) > broj_ukrasa(q->desni,s)) printf("Vise ima u levom\n");
	else if(broj_ukrasa(q->levi,s) < broj_ukrasa(q->desni,s)) printf("Vise ima u desnom\n ");
		else printf("Ima ih isto\n");
}
