#include <stdio.h>
#include <string.h>
#include <stdlib.h>


typedef struct balans{
	char boja[100];
	char oblik[100];
	int bal;
	struct balans *levi, *desni;
}BALANS;


int dubina(BALANS, *p){
	int dl=0, dd=0;
	if(p){
		if(p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		if(dl>dd) return ++dd;
	}
	else return 0;
}


BALANS *lrotacija(BALANS *p){
	BALANS *pom;
	
	pom=p->desni->levi;
	p->desni->levi=p;
	p=p->desni;
	p->levi->desni=pom;
	
	p->levi->bal=dubina(p->levi->desni)-dubina(p->levi->levi);
	p->bal=dubina(p->desni)-dubina(p->levi);
	return p;
}


BALANS *drotacija(BALANS *p){
	BALANS *pom;
	
	pom=p->levi->desni;
	p->levi->desni=p;
	p=p->levi;
	p->desni->levi=pom;
	
	p->desni->bal=dubina(p->desni->desni)-dubina(p->desni->levi);
	p->bal=dubina(p->desni)-dubina(p->levi);
	return p;
}


int Dodaj(BALANS **p2, BALANS *temp){
	BALANS *p;
	p=*p2;
	int rezultat, ink;
	
	rezultat=0;
	
	if(p==NULL){
		p=temp;
		p->levi=NULL;
		p->desni=NULL;
		p->bal=0;
		rezultat=1;
	}
	else{
		if(temp->boja[3] >= p->boja[3] && temp->oblik[1] >= p->oblik[1])
		ink=Dodaj(&(p->desni),temp);
		else ink=Dodaj(&(p->levi),temp);
		p->bal+=ink;
		
		if(ink != 0 && p->bal != 0){
			if(p->bal < -1){
				if(p->levi->bal < 0){
					p=drotacija(p);
				}
				else{
					p->levi=lrotacija(p->levi);
					p=drotacija(p);
				}
			}
			else if(p->bal > 1){
				if(p->desni->bal > 0){
					p=lrotacija(p);
				}
				else{
					p->desni=drotacija(p->desni);
					p=lrotacija(p);
				}
			}
			(*p2)=p;
			return rezultat;
		}
	}
}


void Kreiraj(BALANS **p2){
	BALANS *p;
	BALANS *temp;
	int n,i;
	
	p=(*p2);
	scanf("%d", &n);
	getchar();
	for(i=0; i<n; i++){
		temp=malloc(sizeof(BALANS));
		gets(temp->boja);
		gets(temp->oblik);
		Dodaj(&p, temp)
	}
	(*p2)=p;
}



void Ispis(BALANS *p){
	if(p != NULL){
		Ispis(p->levi);
		printf("%s %s Bal: %d\n", p->boja, p->oblik, p->bal);
		Ispis(p->desni);
	}
}

BALANS *Brisi(BALANS *p, BALANS *novo, char oblik[]){
	if(p != NULL){
		novo=Brisi(p->levi, novo, oblik);
		novo=Brisi(p->desni, novo, oblik);
		
		p->levi=p->desni=NULL;
		
		if(strcmp(p->oblik,oblik)!=0) Dodaj(&novo, p);
		else free(p);
	}
	return novo;
}

void Brojac(BALANS *p, int *br, char *boja){
	if(p != NULL){
		Ispis(p->levi);
		if(strcmp(p->boja,boja)==0) (*br)++;
		Ispis(p->desni);
	}
}

main(){
	BALANS *p=NULL;
	int brl=0,brd=0;
	Kreiraj(&p);
	Ispis(p);
	printf("Na vrhu jelke oblik je: %s\n",p->oblik);
	p=Brisi(p,NULL,p->oblik);
	Ispis(p);
	printf("Na vrhu jelke boja je: %s\n",p->boja);
	Brojac(p->levi,&brl,p->boja);
	Brojac(p->desni&brd,p->boja);
	if(brl>brd)
	printf("Ima vise na levoj strani\n");
	else printf("Ima vise na desnoj\n");
}
