#include <stdio.h>
#include <stdlib.h>
#include <string.h>
enum{CRNA,CRVENA};
struct stablo{
	struct stablo*levi,*desni,*roditelj;
	int boja;
	char ukras[8];
	char oblik[6];
};
void ispis(struct stablo*d){
	if(d){
		ispis(d->levi);
		printf("%s %s boja:%d\n",d->oblik,d->ukras,d->boja);
		ispis(d->desni);
	}
}
int radi1(struct stablo*p){
	if(!strcmp(p->ukras,"zlatna"))return 3;
	if(!strcmp(p->ukras,"crvena"))return 2;
	if(!strcmp(p->ukras,"srebrna"))return 1;	
}
int radi2(struct stablo*p){
	if(!strcmp(p->oblik,"sfera"))return 1;
	else return 2;
}
void lrotacija(struct stablo**d){
	struct stablo*poml,*pomd;
	poml=*d;pomd=poml->desni;
	if(poml->roditelj){
		if(poml->roditelj->levi==poml)poml->roditelj->levi=pomd;
		else poml->roditelj->desni=pomd;
	}
	if(pomd->levi)pomd->levi->roditelj=poml;
	pomd->roditelj=poml->roditelj;
	poml->roditelj=pomd;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*d=pomd;
}
void drotacija(struct stablo**d){
	struct stablo*poml,*pomd;
	pomd=*d;poml=pomd->levi;
	if(pomd->roditelj){
		if(pomd->roditelj->levi==pomd)pomd->roditelj->levi=poml;
		else pomd->roditelj->desni=poml;
	}
	if(poml->desni)poml->desni->roditelj=pomd;
	poml->roditelj=pomd->roditelj;
	pomd->roditelj=poml;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*d=poml;
}
void boje_fix(struct stablo**d,struct stablo*t){
	struct stablo*y;
	while(t->roditelj && t->roditelj->boja==CRVENA){
		if(t->roditelj->roditelj->levi==t->roditelj){
			y=t->roditelj->roditelj->desni;
			if(y && y->boja==CRVENA){
				y->boja=CRNA;
				t->roditelj->boja=CRNA;
				y->roditelj->boja=CRVENA;
				t=t->roditelj->roditelj;
			}
			else{
				if(t->roditelj->desni==t){
					t=t->roditelj;
					lrotacija(&t);
					t=t->levi;
				}
				t->boja=CRVENA;
				t->roditelj->boja=CRNA;
				t->roditelj->roditelj->boja=CRVENA;
				t=t->roditelj->roditelj;
				drotacija(&t);
				if(!t->roditelj)*d=t;
			}
		}
		else{
			y=t->roditelj->roditelj->levi;
			if(y && y->boja==CRVENA){
				y->boja=CRNA;
				t->roditelj->boja=CRNA;
				y->roditelj->boja=CRVENA;
				t=t->roditelj->roditelj;
			}
			else{
				if(t->roditelj->levi==t){
					t=t->roditelj;
					drotacija(&t);
					t=t->desni;
				}
				t->boja=CRVENA;
				t->roditelj->boja=CRNA;
				t->roditelj->roditelj->boja=CRVENA;
				t=t->roditelj->roditelj;
				lrotacija(&t);
				if(!t->roditelj)*d=t;
			}
		}
	}
(*d)->boja=CRNA;
}
void dodaj(struct stablo**d,struct stablo*t){
	struct stablo*pom1=*d,*pom2=NULL;
	while(pom1){
		pom2=pom1;
		int br1=radi1(pom1);
		int br2=radi1(t);
		if(br1==br2){
			br1=radi2(pom1);
			br2=radi2(t);
			if(br1>br2)pom1=pom1->levi;
			else pom1=pom1->desni;
		}
		else{
			br1=radi1(pom1);
			br2=radi1(t);
			if(br1>br2)pom1=pom1->levi;
			else pom1=pom1->desni;
			}
	}
	if(!pom2)*d=t;
	else{
		int br1=radi1(pom2);
		int br2=radi1(t);
		if(br1==br2){
			if(br1>br2)pom2->levi=t;
			else pom2->desni=t;
		}
		else{
			br1=radi1(pom2);
			br2=radi1(t);
			if(br1>br2)pom2->levi=t;
			else pom2->desni=t;
		}
		t->roditelj=pom2;
	}
	boje_fix(d,t);
}
void form(struct stablo**drvo,char*dat){
	int i,n;
	FILE*in=fopen(dat,"r");
		fscanf(in,"%d",&n);
		for(i=0;i<n;i++){
			fgetc(in);
			char s1[50];
			char s2[50];
			fscanf(in,"%s",s1);
			fgetc(in);
			fscanf(in,"%s",s2);
			struct stablo*temp=(struct stablo*)malloc(sizeof(struct stablo));
			temp->levi=temp->desni=temp->roditelj=NULL;
			temp->boja=CRVENA;
			strcpy(temp->ukras,s1);
			strcpy(temp->oblik,s2);
			dodaj(drvo,temp);
		}
	fclose(in);
}
void brisi(struct stablo*d,char*s,struct stablo**novo){
	if(d){
		if(strcmp(d->ukras,s)){
			struct stablo*temp=(struct stablo*)malloc(sizeof(struct stablo));
			temp->levi=temp->desni=temp->roditelj=NULL;
			temp->boja=CRVENA;
			strcpy(temp->ukras,d->ukras);
			strcpy(temp->oblik,d->ukras);
			dodaj(novo,temp);
		}
		brisi(d->levi,s,novo);
		brisi(d->desni,s,novo);
	}
}
void nadji(struct stablo*d,int *levi,int *desni,char*s){
	if(d){
		if((d->levi)&&(!strcmp(d->levi->ukras,s)))(*levi)++;
		if((d->desni)&&(!strcmp(d->desni->ukras,s)))(*desni)++;
		nadji(d->levi,levi,desni,s);
		nadji(d->desni,levi,desni,s);
	}
}
main(int argc,char*argv[]){
	int bl=0,bd=0;
	struct stablo*drvo=NULL;
	struct stablo*novo=NULL;
	form(&drvo,argv[1]);
	ispis(drvo);
	brisi(drvo->levi,drvo->ukras,&novo);
	brisi(drvo->desni,drvo->ukras,&novo);
	printf("\n");
	ispis(novo);
	nadji(novo,&bl,&bd,novo->ukras);
	if(bl>bd)printf("levo\n");
	else{
		if(bl<bd)printf("Desno\n");
		else printf("Isto\n");
	}
}
